package hatelace.instructions;

import hatelace.*;

public class Copy extends Instruction {
    private Word imm;
    private Address dest;

    /** Copy immediate value to memory address. */
    public Copy(Word imm, Address dest) {
        this.imm = imm;
        this.dest = dest;
    }

    public void execute(Memory memory, ProgramCounter PC) {
        memory.write(this.dest, this.imm);
        PC.incPC();
    }

    protected String opcode() {
        return "CPY";
    }

    protected Object[] operands() {
        return new Object[] {this.imm, this.dest};
    }

    public String toString() {
        return String.format("%s %s [%s]", this.opcode(), this.imm, this.dest);
    }
}
